unit vklayout_de;

{$mode objfpc}{$H+}
{$Codepage UTF8}

interface

uses
    Classes
  , LCLType
  , VirtualKeyboard
  ;

procedure DefineLayout_DE(Layout: TKeyboardLayout);

implementation

procedure DefineLayout_DE(Layout: TKeyboardLayout);
begin
  with TLayoutLine(Layout.Add) do
  begin
    NewKey('^').AddShift('°');
    NewKey('1').AddShift('!');
    NewKey('2').AddShift('"').Add('²', [ssAltGr]);
    NewKey('3').AddShift('§').Add('³', [ssAltGr]);
    NewKey('4').AddShift('$');
    NewKey('5').AddShift('%');
    NewKey('6').Add('&', '&', [ssShift]);
    NewKey('7').AddShift('/').Add('{', [ssAltGr]);
    NewKey('8').AddShift('(').Add('[', [ssAltGr]);
    NewKey('9').AddShift(')').Add(']', [ssAltGr]);
    NewKey('0').AddShift('=').Add('}', [ssAltGr]);
    NewKey('ß').AddShift('?').Add('\', [ssAltGr]);
    NewKey('´').AddShift('´');
    NewKey.Add(char(VK_BACK), '←', []); // Backspace
  end;

  with TLayoutLine(Layout.Add) do
  begin
    NewKey.Add(Char(VK_TAB), UTF8Encode(UnicodeChar($21B9)), []); // Tabulator
    NewKey('q').AddShift('Q').Add('@',[ssAltGr]);
    NewKey('w').AddShift('W');
    NewKey('e').AddShift('E').Add('€', [ssAltGr]);
    NewKey('r').AddShift('R');
    NewKey('t').AddShift('T');
    NewKey('z').AddShift('Z');
    NewKey('u').AddShift('U');
    NewKey('i').AddShift('I');
    NewKey('o').AddShift('O');
    NewKey('p').AddShift('P');
    NewKey('ü').AddShift('Ü');
    NewKey('+').AddShift('*').Add('~', [ssAltGr]);
  end;

  with TLayoutLine(Layout.Add) do
  begin
    NewKey.Add(Char(VK_CAPITAL), UTF8Encode(UnicodeChar($21E9)), []); // Capslock
    NewKey('a').AddShift('A');
    NewKey('s').AddShift('S');
    NewKey('d').AddShift('D');
    NewKey('f').AddShift('F');
    NewKey('g').AddShift('G');
    NewKey('h').AddShift('H');
    NewKey('j').AddShift('J');
    NewKey('k').AddShift('K');
    NewKey('l').AddShift('L');
    NewKey('ö').AddShift('Ö');
    NewKey('ä').AddShift('Ä');
    NewKey('#').AddShift('''');
  end;

  with TLayoutLine(Layout.Add) do
  begin
    NewKey.Add(Char(VK_LSHIFT), UTF8Encode(UnicodeChar($21EE)), []); // Shift
    NewKey('<').AddShift('<').Add('|', [ssAltGr]);
    NewKey('y').AddShift('Y');
    NewKey('x').AddShift('X');
    NewKey('c').AddShift('C');
    NewKey('v').AddShift('V');
    NewKey('b').AddShift('B');
    NewKey('n').AddShift('N');
    NewKey('m').AddShift('M').Add('µ', [ssAltGr]);
    NewKey(',').AddShift(';');
    NewKey('.').AddShift(':');
    NewKey('-').AddShift('_');
    NewKey.Add(Char(VK_RSHIFT), UTF8Encode(UnicodeChar($21EE)), []); // Shift
  end;

  with TLayoutLine(Layout.Add) do
  begin
    NewKey.Add(Char(VK_LCONTROL), 'Strg', []).SetButtonWidth(2);
    NewKey.Add(Char(VK_LMENU), 'Alt', []).SetButtonWidth(2);
    NewKey.Add(Char(VK_SPACE), UTF8Encode(UnicodeChar($2423)), []).SetButtonWidth(8);
    NewKey.Add(Char(VK_RMENU), 'AltGr', []).SetButtonWidth(2);
    NewKey.Add(Char(VK_RCONTROL), 'Strg', []).SetButtonWidth(2);
  end;
end;

initialization
  OnDefaultLayout := @DefineLayout_DE;
end.
